/* Tabela OPERADOR: Item do Lanamento de Estoque */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na
tabela OPERADOR */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela OPERADOR utilizando
a tabela Geral de Logs de Operaes */

CREATE OR REPLACE TRIGGER LOG_GER_OPERADOR
AFTER DELETE OR INSERT OR UPDATE
ON OPERADOR FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(2000); 
  V_DTOPER       DATE;
  V_TAM          INTEGER;
BEGIN 
   V_TIPO := '0'; 
   V_DESC := ''; 
   
   WEBTUNNING(V_DSREMOTEADDR, 
              V_DSREMOTEHOST, 
              V_DSSERVERRDM, 
              V_DSSERVMETHOD, 
              V_DSREMOTEOPER); 
   IF DELETING THEN 
      IF :OLD.CDOPERADOR IS NOT NULL THEN 
         V_DESC := V_DESC || 'Cod=' || :OLD.CDOPERADOR; 
      END IF; 
      IF :OLD.NMOPERADOR IS NOT NULL THEN 
         V_DESC := V_DESC || ' Nome=' || :OLD.NMOPERADOR; 
      END IF; 
      IF :OLD.NMCOMPLOPER IS NOT NULL THEN 
         V_DESC := V_DESC || ' CompNome=' || :OLD.NMCOMPLOPER; 
      END IF; 
      IF :OLD.CDCARGO IS NOT NULL THEN 
         V_DESC := V_DESC || ' Cargo=' || :OLD.CDCARGO; 
      END IF; 
      IF :OLD.CDFUNC IS NOT NULL THEN 
         V_DESC := V_DESC || ' Func=' || :OLD.CDFUNC; 
      END IF; 
      IF :OLD.DTNASCIMENTO IS NOT NULL THEN 
         V_DESC := V_DESC || ' DtNasc=' || TO_CHAR(:OLD.DTNASCIMENTO,'DD/MM/YYYY'); 
      END IF; 
      IF :OLD.IDSENHVARDIA IS NOT NULL THEN 
         V_DESC := V_DESC || ' Senha=' || :OLD.IDSENHVARDIA; 
      END IF; 
      IF :OLD.NMACESSO IS NOT NULL THEN 
         V_DESC := V_DESC || ' NomedeAces=' || :OLD.NMACESSO; 
      END IF; 
      IF :OLD.IDOPERATIVO IS NOT NULL THEN 
         V_DESC := V_DESC || ' SitOper=' || :OLD.IDOPERATIVO; 
      END IF; 
      IF :OLD.DSENDEOPER IS NOT NULL THEN 
         V_DESC := V_DESC || ' End=' || :OLD.DSENDEOPER; 
      END IF; 
      IF :OLD.NMBAIROPER IS NOT NULL THEN 
         V_DESC := V_DESC || ' Bairro=' || :OLD.NMBAIROPER; 
      END IF; 
      IF :OLD.CDPAIS IS NOT NULL THEN 
         V_DESC := V_DESC || ' Pais=' || :OLD.CDPAIS; 
      END IF; 
      IF :OLD.CDMUNICIPIO IS NOT NULL THEN 
         V_DESC := V_DESC || ' Munic=' || :OLD.CDMUNICIPIO; 
      END IF; 
      IF :OLD.NRTELEOPER IS NOT NULL THEN 
         V_DESC := V_DESC || ' Tel=' || :OLD.NRTELEOPER; 
      END IF; 
      IF :OLD.DSEMAILOPER IS NOT NULL THEN 
         V_DESC := V_DESC || ' E-mail=' || :OLD.DSEMAILOPER; 
      END IF; 
      IF :OLD.CDSENEMAILOP IS NOT NULL THEN 
         V_DESC := V_DESC || ' Senha=' || :OLD.CDSENEMAILOP; 
      END IF; 
      IF :OLD.SGESTADO IS NOT NULL THEN 
         V_DESC := V_DESC|| ' Estado='||:OLD.SGESTADO; 
      END IF; 
      IF :OLD.NRCEPOPER IS NOT NULL THEN 
         V_DESC := V_DESC|| ' Cep='||:OLD.NRCEPOPER; 
      END IF; 
      V_TIPO         := '3'; 
      V_ITPESQ       := :OLD.CDOPERADOR; 
   ELSE 
      IF UPDATING THEN 
         IF (NVL(:OLD.CDOPERADOR,'!')   <> NVL(:NEW.CDOPERADOR,'!'))   OR 
            (NVL(:OLD.NMOPERADOR,'!')   <> NVL(:NEW.NMOPERADOR,'!'))   OR 
            (NVL(:OLD.NMCOMPLOPER,'!')  <> NVL(:NEW.NMCOMPLOPER,'!'))  OR 
            (NVL(:OLD.CDCARGO,'!')      <> NVL(:NEW.CDCARGO,'!'))      OR 
            (NVL(:OLD.CDFUNC,'!')       <> NVL(:NEW.CDFUNC,'!'))       OR 
            (NVL(:OLD.DTNASCIMENTO,SYSDATE) <> NVL(:NEW.DTNASCIMENTO,SYSDATE)) OR 
            (NVL(:OLD.IDSENHVARDIA,'!') <> NVL(:NEW.IDSENHVARDIA,'!')) OR 
            (NVL(:OLD.NMACESSO,'!')     <> NVL(:NEW.NMACESSO,'!'))     OR 
            (NVL(:OLD.IDOPERATIVO,'!')  <> NVL(:NEW.IDOPERATIVO,'!'))  OR 
            (NVL(:OLD.DSENDEOPER,'!')   <> NVL(:NEW.DSENDEOPER,'!'))   OR 
            (NVL(:OLD.NMBAIROPER,'!')   <> NVL(:NEW.NMBAIROPER,'!'))   OR 
            (NVL(:OLD.IDSTATUSENHA,'!')   <> NVL(:NEW.IDSTATUSENHA,'!'))   OR 
            (NVL(:OLD.CDPAIS,'!')       <> NVL(:NEW.CDPAIS,'!'))       OR 
            (NVL(:OLD.CDMUNICIPIO,'!')  <> NVL(:NEW.CDMUNICIPIO,'!'))  OR 
            (NVL(:OLD.NRTELEOPER,'!')   <> NVL(:NEW.NRTELEOPER,'!'))   OR 
            (NVL(:OLD.DSEMAILOPER,'!')  <> NVL(:NEW.DSEMAILOPER,'!'))  OR 
            (NVL(:OLD.SGESTADO,'!')     <> NVL(:NEW.SGESTADO,'!'))     OR 
            (NVL(:OLD.NRCEPOPER,'!')    <> NVL(:NEW.NRCEPOPER,'!'))    OR 
            (NVL(:OLD.CDSENEMAILOP,'!') <> NVL(:NEW.CDSENEMAILOP,'!')) THEN 
            V_TIPO         := '2'; 
            V_ITPESQ       := :OLD.CDOPERADOR; 
            IF NVL(:OLD.CDOPERADOR,'!') <> NVL(:NEW.CDOPERADOR,'!') THEN 
               V_DESC := V_DESC || 'Cod=' || :NEW.CDOPERADOR; 
            END IF; 
            IF NVL(:OLD.NMOPERADOR,'!') <> NVL(:NEW.NMOPERADOR,'!') THEN 
               V_DESC := V_DESC || ' Nome=' || :NEW.NMOPERADOR; 
            END IF; 
            IF NVL(:OLD.NMCOMPLOPER,'!') <> NVL(:NEW.NMCOMPLOPER,'!') THEN 
               V_DESC := V_DESC || ' CompNome=' || :NEW.NMCOMPLOPER; 
            END IF; 
            IF NVL(:OLD.CDCARGO,'!') <> NVL(:NEW.CDCARGO,'!') THEN 
               V_DESC := V_DESC || ' Cargo=' || :NEW.CDCARGO; 
            END IF; 
            IF NVL(:OLD.CDFUNC,'!') <> NVL(:NEW.CDFUNC,'!') THEN 
               V_DESC := V_DESC || ' Func=' || :NEW.CDFUNC; 
            END IF; 
            IF NVL(:OLD.DTNASCIMENTO, SYSDATE) <> NVL(:NEW.DTNASCIMENTO, SYSDATE) THEN 
               V_DESC := V_DESC || ' DtNasc=' || TO_CHAR(:NEW.DTNASCIMENTO,'DD/MM/YYYY'); 
            END IF; 
            IF NVL(:OLD.IDSENHVARDIA,'!') <> NVL(:NEW.IDSENHVARDIA,'!') THEN 
               V_DESC := V_DESC || ' Senha=' || :NEW.IDSENHVARDIA; 
            END IF; 
            IF NVL(:OLD.NMACESSO,'!') <> NVL(:NEW.NMACESSO,'!') THEN 
               V_DESC := V_DESC || ' NomedeAces=' || :NEW.NMACESSO; 
            END IF; 
            IF NVL(:OLD.IDOPERATIVO,'!') <> NVL(:NEW.IDOPERATIVO,'!') THEN 
               V_DESC := V_DESC || ' SitOper=' || :NEW.IDOPERATIVO; 
            END IF; 
            IF NVL(:OLD.DSENDEOPER,'!') <> NVL(:NEW.DSENDEOPER,'!') THEN 
               V_DESC := V_DESC || ' End=' || :NEW.DSENDEOPER; 
            END IF; 
            IF NVL(:OLD.NMBAIROPER,'!') <> NVL(:NEW.NMBAIROPER,'!') THEN 
               V_DESC := V_DESC || ' Bairro=' || :NEW.NMBAIROPER; 
            END IF; 
            IF NVL(:OLD.CDPAIS,'!') <> NVL(:NEW.CDPAIS,'!') THEN 
               V_DESC := V_DESC || ' Pais=' || :NEW.CDPAIS; 
            END IF; 
            IF NVL(:OLD.CDMUNICIPIO,'!') <> NVL(:NEW.CDMUNICIPIO,'!') THEN 
               V_DESC := V_DESC || ' Munic=' || :NEW.CDMUNICIPIO; 
            END IF; 
            IF NVL(:OLD.NRTELEOPER,'!') <> NVL(:NEW.NRTELEOPER,'!') THEN 
               V_DESC := V_DESC || ' Tel=' || :NEW.NRTELEOPER; 
            END IF; 
            IF NVL(:OLD.DSEMAILOPER,'!') <> NVL(:NEW.DSEMAILOPER,'!') THEN 
               V_DESC := V_DESC || ' E-mail=' || :NEW.DSEMAILOPER; 
            END IF; 
            IF NVL(:OLD.CDSENEMAILOP,'!') <> NVL(:NEW.CDSENEMAILOP,'!') THEN 
               V_DESC := V_DESC || ' Senha=' || :NEW.CDSENEMAILOP; 
            END IF; 
            IF NVL(:OLD.SGESTADO,'!') <> NVL(:NEW.SGESTADO,'!') THEN 
              V_DESC := V_DESC|| ' Estado='||:NEW.SGESTADO; 
            END IF; 
            IF NVL(:OLD.NRCEPOPER,'!') <> NVL(:NEW.NRCEPOPER,'!') THEN 
              V_DESC := V_DESC|| ' Cep='||:NEW.NRCEPOPER; 
            END IF; 
             
            IF NVL(:OLD.IDSTATUSENHA,'!') <> NVL(:NEW.IDSTATUSENHA,'!') THEN 
               V_DESC := V_DESC || ' Op.DesbloqSenha=' || :NEW.CDOPERESPLIBSEN; 
            END IF; 
         END IF; 
      ELSE 
         V_TIPO         := '1'; 
         V_ITPESQ       := :NEW.CDOPERADOR; 
         IF :OLD.SGESTADO IS NOT NULL THEN 
            V_DESC := V_DESC|| ' Estado='||:NEW.SGESTADO; 
         END IF; 
         IF :NEW.CDOPERADOR IS NOT NULL THEN 
            V_DESC := V_DESC || 'Cod=' || :NEW.CDOPERADOR; 
         END IF; 
         IF :NEW.NMOPERADOR IS NOT NULL THEN 
            V_DESC := V_DESC || ' Nome=' || :NEW.NMOPERADOR; 
         END IF; 
         IF :NEW.NMCOMPLOPER IS NOT NULL THEN 
            V_DESC := V_DESC || ' CompNome=' || :NEW.NMCOMPLOPER; 
         END IF; 
         IF :NEW.CDCARGO IS NOT NULL THEN 
            V_DESC := V_DESC || ' Cargo=' || :NEW.CDCARGO; 
         END IF; 
         IF :NEW.CDFUNC IS NOT NULL THEN 
            V_DESC := V_DESC || ' Func=' || :NEW.CDFUNC; 
         END IF; 
         IF :NEW.DTNASCIMENTO IS NOT NULL THEN 
            V_DESC := V_DESC || ' DtNasc=' || TO_CHAR(:NEW.DTNASCIMENTO,'DD/MM/YYYY'); 
         END IF; 
         IF :NEW.IDSENHVARDIA IS NOT NULL THEN 
            V_DESC := V_DESC || ' Senha=' || :NEW.IDSENHVARDIA; 
         END IF; 
         IF :NEW.NMACESSO IS NOT NULL THEN 
            V_DESC := V_DESC || ' NomedeAces=' || :NEW.NMACESSO; 
         END IF; 
         IF :NEW.IDOPERATIVO IS NOT NULL THEN 
            V_DESC := V_DESC || ' SitOper=' || :NEW.IDOPERATIVO; 
         END IF; 
         IF :NEW.DSENDEOPER IS NOT NULL THEN 
            V_DESC := V_DESC || ' End=' || :NEW.DSENDEOPER; 
         END IF; 
         IF :NEW.NMBAIROPER IS NOT NULL THEN 
            V_DESC := V_DESC || ' Bairro=' || :NEW.NMBAIROPER; 
         END IF; 
         IF :NEW.CDPAIS IS NOT NULL THEN 
            V_DESC := V_DESC || ' Pais=' || :NEW.CDPAIS; 
         END IF; 
         IF :NEW.CDMUNICIPIO IS NOT NULL THEN 
            V_DESC := V_DESC || ' Munic=' || :NEW.CDMUNICIPIO; 
         END IF; 
         IF :NEW.NRTELEOPER IS NOT NULL THEN 
            V_DESC := V_DESC || ' Tel=' || :NEW.NRTELEOPER; 
         END IF; 
         IF :NEW.DSEMAILOPER IS NOT NULL THEN 
            V_DESC := V_DESC || ' E-mail=' || :NEW.DSEMAILOPER; 
         END IF; 
         IF :NEW.CDSENEMAILOP IS NOT NULL THEN 
            V_DESC := V_DESC || ' Senha=' || :NEW.CDSENEMAILOP; 
         END IF; 
         IF :OLD.NRCEPOPER IS NOT NULL THEN 
            V_DESC := V_DESC|| ' Cep='||:NEW.NRCEPOPER; 
         END IF;
      END IF;
   END IF;
   IF V_TIPO <> '0' THEN
      IF NOT V_DESC IS NULL THEN
         V_USUARIO := '  ';
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;
            V_TAM := LENGTH(V_DESC);
            WHILE (V_TAM >= 0) LOOP
               INSERT INTO LOGOPERA
                  (NMTABELA,   DTOPERACAO, NMRESPOPER, IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                   DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,  DSMETUSUOPER, CDORESPOPER)
               VALUES
                  ('OPERADOR',  V_DTOPER, V_USUARIO,  V_TIPO, V_ITPESQ, SUBSTR(V_DESC,1,400),
                   V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER);
               V_DESC := SUBSTR(V_DESC, 400, V_TAM);
               V_TAM := LENGTH(V_DESC);
            END LOOP;
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_GER_OPERADOR','6.05.000'); END;
/
